/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.57 from the
 * contents of BackupPC_XS.xs. Do not edit this file, edit BackupPC_XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "BackupPC_XS.xs"
/*
 * XS glue for perl interface to BackupPC libraries.
 *
 * Copyright (C) 2013 Craig Barratt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, visit the http://fsf.org website.
 */


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <backuppc.h>

typedef bpc_fileZIO_fd          *BackupPC__XS__FileZIO;
typedef bpc_refCount_info       *BackupPC__XS__PoolRefCnt;
typedef bpc_deltaCount_info     *BackupPC__XS__DeltaRefCnt;
typedef bpc_poolWrite_info      *BackupPC__XS__PoolWrite;
typedef bpc_attrib_dir          *BackupPC__XS__Attrib;
typedef bpc_attribCache_info    *BackupPC__XS__AttribCache;

#define hv_get_int(hv, key, value)       { SV** svp = hv_fetch((hv), (key), strlen(key), 0); if ( svp && *svp ) (value) = SvIV(*svp); }
#define hv_get_uint(hv, key, value)      { SV** svp = hv_fetch((hv), (key), strlen(key), 0); if ( svp && *svp ) (value) = SvUV(*svp); }
#define hv_get_str(hv, key, value, len)  { SV** svp = hv_fetch((hv), (key), strlen(key), 0); if ( svp && *svp ) (value) = SvPV(*svp, len); }

static HV* convert_file2hv(bpc_attrib_file *file, char *fileName)
{
    HV *rh;
    size_t listLen, i;

    rh = newHV();
    (void)hv_store(rh, "uid", 3,      newSVuv(file->uid), 0);
    (void)hv_store(rh, "gid", 3,      newSVuv(file->gid), 0);
    (void)hv_store(rh, "name", 4,     newSVpvn(fileName, strlen(fileName)), 0);
    (void)hv_store(rh, "type", 4,     newSVuv(file->type), 0);
    (void)hv_store(rh, "mode", 4,     newSVuv(file->mode), 0);
    (void)hv_store(rh, "size", 4,     newSVuv(file->size), 0);
    (void)hv_store(rh, "mtime", 5,    newSViv(file->mtime), 0);
    (void)hv_store(rh, "inode", 5,    newSVuv(file->inode), 0);
    (void)hv_store(rh, "nlinks", 6,   newSVuv(file->nlinks), 0);
    (void)hv_store(rh, "digest", 6,   newSVpvn((char*)file->digest.digest, file->digest.len), 0);
    (void)hv_store(rh, "compress", 8, newSVuv(file->compress), 0);

    if ( (listLen = bpc_attrib_xattrList(file, NULL, 0, 0)) > 0 ) {
        char *keys = malloc(listLen), *p;

        if ( keys && bpc_attrib_xattrList(file, keys, listLen, 0) > 0 ) {
            HV *rhAttr = newHV();
            for ( i = 0, p = keys ; i < listLen ; ) {
                int len = strlen(p);
                /*
                 * xattr keys include the \0 terminating byte in the length, so add 1 here,
                 * and subtract 1 in the hv_store() below.
                 */
                bpc_attrib_xattr *xattr = bpc_attrib_xattrGet(file, p, len + 1, 0);
                p += len + 1;
                i += len + 1;
                if ( !xattr ) continue;
                (void)hv_store(rhAttr, xattr->key.key, xattr->key.keyLen - 1, newSVpvn(xattr->value, xattr->valueLen), 0);
            }
            (void)hv_store(rh, "xattr", 5, newRV_noinc((SV*)rhAttr), 0);
        }
        if ( keys ) free(keys);
    }
    return rh;
}

static void convert_hv2file(HV *hv, bpc_attrib_file *file)
{
    char *digestStr = "";
    STRLEN digestLen = 0;
    SV** svp;

    hv_get_uint(hv, "uid", file->uid);
    hv_get_uint(hv, "gid", file->gid);
    hv_get_uint(hv, "type", file->type);
    hv_get_uint(hv, "mode", file->mode);
    hv_get_uint(hv, "size", file->size);
    hv_get_int(hv, "mtime", file->mtime);
    hv_get_uint(hv, "inode", file->inode);
    hv_get_uint(hv, "nlinks", file->nlinks);
    hv_get_uint(hv, "compress", file->compress);
    hv_get_str(hv,  "digest", digestStr, digestLen);
    if ( 0 < digestLen && digestLen <= sizeof(file->digest.digest) ) {
        memcpy(file->digest.digest, digestStr, digestLen);
        file->digest.len = digestLen;
    } else {
        file->digest.len = 0;
    }
    if ( (svp = hv_fetch(hv, "xattr", 5, 0)) && *svp ) {
        if ( SvTYPE(SvRV(*svp)) != SVt_PVHV ) {
            bpc_attrib_xattrDeleteAll(file);
        } else {
            HE *he;
            HV *hvXattr = (HV*)SvRV(*svp);
            /*
             * clear out the old xattrs, and copy in the new
             */
            bpc_attrib_xattrDeleteAll(file);
            hv_iterinit(hvXattr);
            while ( (he = hv_iternext(hvXattr)) ) {
                I32 keyLen;
                STRLEN valueLen;
                char *key = hv_iterkey(he, &keyLen), *value;
                SV *valSV = hv_iterval(hvXattr, he);

                value = SvPV(valSV, valueLen);
                bpc_attrib_xattrSetValue(file, key, keyLen + 1, value, valueLen);
            }
        }
    }
}

#line 138 "BackupPC_XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

/* simple backcompat versions of the TARGx() macros with no optimisation */
#ifndef TARGi
#  define TARGi(iv, do_taint) sv_setiv_mg(TARG, iv)
#  define TARGu(uv, do_taint) sv_setuv_mg(TARG, uv)
#  define TARGn(nv, do_taint) sv_setnv_mg(TARG, nv)
#endif

#line 289 "BackupPC_XS.c"

XS_EUPXS(XS_BackupPC__XS__FileZIO_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_open)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fileName, writeFile, compressLevel");
    {
	char *	fileName = (char *)SvPV_nolen(ST(0))
;
	int	writeFile = (int)SvIV(ST(1))
;
	int	compressLevel = (int)SvIV(ST(2))
;
	BackupPC__XS__FileZIO	RETVAL;
#line 138 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_fileZIO_fd));
        if ( bpc_fileZIO_open(RETVAL, fileName, writeFile, compressLevel) < 0 ) {
            free(RETVAL);
            XSRETURN_UNDEF;
        }
    }
#line 313 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::FileZIO", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_fdopen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_fdopen)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stream, writeFile, compressLevel");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	int	writeFile = (int)SvIV(ST(1))
;
	int	compressLevel = (int)SvIV(ST(2))
;
	BackupPC__XS__FileZIO	RETVAL;
#line 154 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_fileZIO_fd));
        if ( bpc_fileZIO_fdopen(RETVAL, stream, writeFile, compressLevel) < 0 ) {
            free(RETVAL);
            XSRETURN_UNDEF;
        }
    }
#line 347 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::FileZIO", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	BackupPC__XS__FileZIO	fd;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::FileZIO::DESTROY",
			"fd")
;
#line 168 "BackupPC_XS.xs"
        bpc_fileZIO_close(fd);
        free(fd);
#line 380 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	BackupPC__XS__FileZIO	fd;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::close",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 175 "BackupPC_XS.xs"
    {
        bpc_fileZIO_close(fd);
    }
#line 412 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_rewind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_rewind)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	BackupPC__XS__FileZIO	fd;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::rewind",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 183 "BackupPC_XS.xs"
    {
        RETVAL = bpc_fileZIO_rewind(fd);
    }
#line 446 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, data");
    {
	BackupPC__XS__FileZIO	fd;
	SV *	data = ST(1)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::write",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 194 "BackupPC_XS.xs"
    {
        char *str;
        STRLEN len;

        if ( SvROK(data) ) {
            str = SvPV(SvRV(data), len);
            RETVAL = bpc_fileZIO_write(fd, (unsigned char*)str, len);
        } else {
            RETVAL = -1;
        }
    }
#line 492 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_read)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, data, len");
    {
	BackupPC__XS__FileZIO	fd;
	SV *	data = ST(1)
;
	STRLEN	len = (STRLEN)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::read",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 214 "BackupPC_XS.xs"
    {
        char *str;
        SV *d;
        STRLEN dLen;

        if ( SvROK(data) ) {
            d = SvRV(data);
            if (! SvOK(d))
                sv_setpvs(d, "");
            SvGROW(d, len);
            str = SvPV(d, dLen);
            RETVAL = bpc_fileZIO_read(fd, (unsigned char*)str, len);
            if ( RETVAL >= 0 ) {
                SvCUR_set(d, RETVAL);
            } else {
                SvCUR_set(d, 0);
            }
        } else {
            RETVAL = -1;
        }
    }
#line 550 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_readLine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_readLine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	BackupPC__XS__FileZIO	fd;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::readLine",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 242 "BackupPC_XS.xs"
    {
        char *str;
        size_t strLen;
        if ( bpc_fileZIO_readLine(fd, &str, &strLen) || !str ) XSRETURN_UNDEF;
        RETVAL = newSVpvn(str, strLen);
    }
#line 588 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileZIO_writeTeeStderr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileZIO_writeTeeStderr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, tee");
    {
	BackupPC__XS__FileZIO	fd;
	int	tee = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::FileZIO")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    fd = INT2PTR(BackupPC__XS__FileZIO,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::FileZIO::writeTeeStderr",
			"fd", "BackupPC::XS::FileZIO",
			refstr, ST(0)
		);
	}
;
#line 256 "BackupPC_XS.xs"
        bpc_fileZIO_writeTeeStderr(fd, tee);
#line 622 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "entryCnt = 65536");
    {
	int	entryCnt;
	BackupPC__XS__PoolRefCnt	RETVAL;

	if (items < 1)
	    entryCnt = 65536;
	else {
	    entryCnt = (int)SvIV(ST(0))
;
	}
#line 264 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_refCount_info));
        bpc_poolRefInit((bpc_refCount_info*)RETVAL, entryCnt);
    }
#line 649 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::PoolRefCnt", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__PoolRefCnt	info;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::PoolRefCnt::DESTROY",
			"info")
;
#line 275 "BackupPC_XS.xs"
    {
        bpc_poolRefDestroy(info);
        free(info);
    }
#line 684 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, d");
    {
	BackupPC__XS__PoolRefCnt	info;
	SV *	d = ST(1)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::get",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 285 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;
        int count;

        if ( !SvPOK(d) ) {
            XSRETURN_UNDEF;
        }
        str = SvPV(d, len);
        if ( 0 < len && len < sizeof(digest.digest) ) {
            memcpy(digest.digest, str, len);
            digest.len = len;
            if ( bpc_poolRefGet(info, &digest, &count) ) XSRETURN_UNDEF;
            RETVAL = count;
        } else {
            XSRETURN_UNDEF;
        }
    }
#line 736 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "info, d, count");
    {
	BackupPC__XS__PoolRefCnt	info;
	SV *	d = ST(1)
;
	int	count = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::set",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 313 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;

        if ( !SvPOK(d) ) {
            XSRETURN_UNDEF;
        }
        str = SvPV(d, len);
        if ( 0 < len && len < sizeof(digest.digest) ) {
            memcpy(digest.digest, str, len);
            digest.len = len;
            bpc_poolRefSet(info, &digest, count);
            RETVAL = count;
        } else {
            XSRETURN_UNDEF;
        }
    }
#line 791 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, d");
    {
	BackupPC__XS__PoolRefCnt	info;
	SV *	d = ST(1)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::delete",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 339 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;

        if ( !SvPOK(d) ) {
            XSRETURN_UNDEF;
        }
        str = SvPV(d, len);
        if ( 0 < len && len < sizeof(digest.digest) ) {
            memcpy(digest.digest, str, len);
            digest.len = len;
            if ( bpc_poolRefDelete(info, &digest) ) XSRETURN_UNDEF;
            RETVAL = 1;
        } else {
            XSRETURN_UNDEF;
        }
    }
#line 844 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_incr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_incr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "info, d, delta");
    {
	BackupPC__XS__PoolRefCnt	info;
	SV *	d = ST(1)
;
	int	delta = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::incr",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 366 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;

        if ( !SvPOK(d) ) {
            XSRETURN_UNDEF;
        }
        str = SvPV(d, len);
        if ( 0 < len && len < sizeof(digest.digest) ) {
            memcpy(digest.digest, str, len);
            digest.len = len;
            RETVAL = bpc_poolRefIncr(info, &digest, delta);
        } else {
            XSRETURN_UNDEF;
        }
    }
#line 898 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_iterate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_iterate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, idx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BackupPC__XS__PoolRefCnt	info;
	unsigned int	idx = (unsigned int)SvUV(ST(1))
;
#line 391 "BackupPC_XS.xs"
        bpc_digest digest;
        int count;
#line 921 "BackupPC_XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::iterate",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 394 "BackupPC_XS.xs"
    {
        if ( !bpc_poolRefIterate(info, &digest, &count, &idx) ) {
            EXTEND(SP, 3);
            PUSHs(sv_2mortal(newSVpvn((char*)digest.digest, digest.len)));
            PUSHs(sv_2mortal(newSViv(count)));
            PUSHs(sv_2mortal(newSViv(idx)));
        }
    }
#line 945 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_read)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, fileName");
    {
	BackupPC__XS__PoolRefCnt	info;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::read",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 408 "BackupPC_XS.xs"
        RETVAL = bpc_poolRefFileRead(info, fileName);
#line 980 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, fileName");
    {
	BackupPC__XS__PoolRefCnt	info;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::write",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 417 "BackupPC_XS.xs"
        RETVAL = bpc_poolRefFileWrite(info, fileName);
#line 1016 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_print)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__PoolRefCnt	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolRefCnt::print",
			"info", "BackupPC::XS::PoolRefCnt",
			refstr, ST(0)
		);
	}
;
#line 425 "BackupPC_XS.xs"
        bpc_poolRefCountPrint(info);
#line 1048 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaFileInit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaFileInit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "hostDir");
    {
	char *	hostDir = (char *)SvPV_nolen(ST(0))
;
#line 431 "BackupPC_XS.xs"
        bpc_poolRefDeltaFileInitOld(hostDir);
#line 1065 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaFileFlush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaFileFlush)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;
#line 436 "BackupPC_XS.xs"
        RETVAL = bpc_poolRefDeltaFileFlushOld();
#line 1082 "BackupPC_XS.c"
	TARGu((UV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaUpdate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaUpdate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "compress, d, count");
    {
	int	compress = (int)SvIV(ST(0))
;
	SV *	d = ST(1)
;
	int	count = (int)SvIV(ST(2))
;
#line 446 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;

        if ( SvPOK(d) ) {
            str = SvPV(d, len);
            if ( 0 < len && len < sizeof(digest.digest) ) {
                memcpy(digest.digest, str, len);
                digest.len = len;
                bpc_poolRefDeltaUpdateOld(compress, &digest, count);
            }
        }
    }
#line 1118 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaPrint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolRefCnt_DeltaPrint)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 464 "BackupPC_XS.xs"
        bpc_poolRefDeltaPrintOld();
#line 1133 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "targetDir");
    {
	char *	targetDir = (char *)SvPV_nolen(ST(0))
;
	BackupPC__XS__DeltaRefCnt	RETVAL;
#line 472 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_deltaCount_info));
        bpc_poolRefDeltaFileInit((bpc_deltaCount_info*)RETVAL, targetDir);
    }
#line 1154 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::DeltaRefCnt", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__DeltaRefCnt	info;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::DeltaRefCnt::DESTROY",
			"info")
;
#line 483 "BackupPC_XS.xs"
    {
        bpc_poolRefDeltaFileDestroy(info);
        free(info);
    }
#line 1189 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__DeltaRefCnt	info;
	unsigned int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::DeltaRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::DeltaRefCnt::flush",
			"info", "BackupPC::XS::DeltaRefCnt",
			refstr, ST(0)
		);
	}
;
#line 492 "BackupPC_XS.xs"
        RETVAL = bpc_poolRefDeltaFileFlush(info);
#line 1221 "BackupPC_XS.c"
	TARGu((UV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_update)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "info, compress, d, count");
    {
	BackupPC__XS__DeltaRefCnt	info;
	int	compress = (int)SvIV(ST(1))
;
	SV *	d = ST(2)
;
	int	count = (int)SvIV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::DeltaRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::DeltaRefCnt::update",
			"info", "BackupPC::XS::DeltaRefCnt",
			refstr, ST(0)
		);
	}
;
#line 503 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        char *str;
        STRLEN len;

        if ( SvPOK(d) ) {
            str = SvPV(d, len);
            if ( 0 < len && len < sizeof(digest.digest) ) {
                memcpy(digest.digest, str, len);
                digest.len = len;
                bpc_poolRefDeltaUpdate(info, compress, &digest, count);
            }
        }
    }
#line 1272 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DeltaRefCnt_print)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__DeltaRefCnt	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::DeltaRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::DeltaRefCnt::print",
			"info", "BackupPC::XS::DeltaRefCnt",
			refstr, ST(0)
		);
	}
;
#line 522 "BackupPC_XS.xs"
        bpc_poolRefDeltaPrint(info);
#line 1302 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolWrite_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolWrite_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "compressLevel, d = NULL");
    {
	int	compressLevel = (int)SvIV(ST(0))
;
	SV *	d;
	BackupPC__XS__PoolWrite	RETVAL;

	if (items < 2)
	    d = NULL;
	else {
	    d = ST(1)
;
	}
#line 531 "BackupPC_XS.xs"
    {
        int ret = 0;

        RETVAL = calloc(1, sizeof(bpc_poolWrite_info));
        if ( d && SvPOK(d) ) {
            bpc_digest digest;
            char *str;
            STRLEN len;

            str = SvPV(d, len);
            if ( 0 < len && len < sizeof(digest.digest) ) {
                memcpy(digest.digest, str, len);
                digest.len = len;
                ret = bpc_poolWrite_open(RETVAL, compressLevel, &digest);
            } else {
                ret = bpc_poolWrite_open(RETVAL, compressLevel, NULL);
            }
        } else {
            ret = bpc_poolWrite_open(RETVAL, compressLevel, NULL);
        }
        if ( ret ) {
            free(RETVAL);
            RETVAL = NULL;
        }
    }
#line 1352 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::PoolWrite", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolWrite_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolWrite_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    {
	BackupPC__XS__PoolWrite	info;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolWrite,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::PoolWrite::DESTROY",
			"info")
;
#line 563 "BackupPC_XS.xs"
    {
        bpc_poolWrite_cleanup(info);
        free(info);
    }
#line 1387 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__PoolWrite_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolWrite_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "info");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BackupPC__XS__PoolWrite	info;
#line 572 "BackupPC_XS.xs"
        int match;
        bpc_digest digest;
        off_t poolFileSize;
        int errorCnt;

#line 1409 "BackupPC_XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolWrite")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolWrite,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolWrite::close",
			"info", "BackupPC::XS::PoolWrite",
			refstr, ST(0)
		);
	}
;
#line 578 "BackupPC_XS.xs"
    {
        bpc_poolWrite_close(info, &match, &digest, &poolFileSize, &errorCnt);
        EXTEND(SP, 4);
        PUSHs(sv_2mortal(newSViv(match)));
        PUSHs(sv_2mortal(newSVpvn((char*)digest.digest, digest.len)));
        PUSHs(sv_2mortal(newSViv(poolFileSize)));
        PUSHs(sv_2mortal(newSViv(errorCnt)));
    }
#line 1433 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__PoolWrite_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolWrite_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "info, data");
    {
	BackupPC__XS__PoolWrite	info;
	SV *	data = ST(1)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolWrite")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolWrite,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolWrite::write",
			"info", "BackupPC::XS::PoolWrite",
			refstr, ST(0)
		);
	}
;
#line 592 "BackupPC_XS.xs"
    {
        char *str;
        STRLEN len;

        if ( SvROK(data) ) {
            str = SvPV(SvRV(data), len);
            RETVAL = bpc_poolWrite_write(info, (unsigned char*)str, len);
        } else {
            RETVAL = -1;
        }
    }
#line 1478 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__PoolWrite_addToPool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__PoolWrite_addToPool)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "info, fileName, v3PoolFile");
    {
	BackupPC__XS__PoolWrite	info;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	int	v3PoolFile = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::PoolWrite")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    info = INT2PTR(BackupPC__XS__PoolWrite,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::PoolWrite::addToPool",
			"info", "BackupPC::XS::PoolWrite",
			refstr, ST(0)
		);
	}
;
#line 612 "BackupPC_XS.xs"
        bpc_poolWrite_addToPool(info, fileName, v3PoolFile);
#line 1514 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__Attrib_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "compressLevel");
    {
	int	compressLevel = (int)SvIV(ST(0))
;
	BackupPC__XS__Attrib	RETVAL;
#line 620 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_attrib_dir));
        bpc_attrib_dirInit(RETVAL, compressLevel);
    }
#line 1535 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::Attrib", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dir");
    {
	BackupPC__XS__Attrib	dir;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::Attrib::DESTROY",
			"dir")
;
#line 631 "BackupPC_XS.xs"
    {
        bpc_attrib_dirDestroy(dir);
        free(dir);
    }
#line 1570 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__Attrib_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_get)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dir, fileName = NULL");
    {
	BackupPC__XS__Attrib	dir;
	char *	fileName;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::get",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    fileName = NULL;
	else {
	    fileName = (char *)SvPV_nolen(ST(1))
;
	}
#line 641 "BackupPC_XS.xs"
    {
        if ( fileName ) {
            bpc_attrib_file *file = bpc_attrib_fileGet(dir, fileName, 0);
            if ( !file ) XSRETURN_UNDEF;
            RETVAL = newRV_noinc((SV*)convert_file2hv(file, file->name));
        } else {
            ssize_t entrySize, i;

            RETVAL = NULL;
            if ( (entrySize = bpc_attrib_getEntries(dir, NULL, 0)) > 0 ) {
                char *entries = malloc(entrySize), *p;

                if ( entries && bpc_attrib_getEntries(dir, entries, entrySize) > 0 ) {
                    HV *rh = newHV();
                    for ( i = 0, p = entries ; i < entrySize ; ) {
                        int len = strlen(p);
                        bpc_attrib_file *file;

                        file = bpc_attrib_fileGet(dir, p, 0);
                        p += len + 1;
                        i += len + 1;
                        if ( !file ) continue;
                        (void)hv_store(rh, file->name, strlen(file->name), newRV_noinc((SV*)convert_file2hv(file, file->name)), 0);
                    }
                    RETVAL = newRV_noinc((SV*)rh);
                }
                if ( entries ) free(entries);
            }
            if ( !RETVAL ) XSRETURN_UNDEF;
        }
    }
#line 1639 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dir, fileName, hv");
    {
	BackupPC__XS__Attrib	dir;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	HV *	hv;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::set",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hv = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"BackupPC::XS::Attrib::set",
				"hv");
		}
	} STMT_END
;
#line 681 "BackupPC_XS.xs"
    {
        bpc_attrib_file *file = bpc_attrib_fileGet(dir, fileName, 0);

        RETVAL = file ? 1 : 0;
        if ( !file ) {
            file = bpc_attrib_fileGet(dir, fileName, 1);
            bpc_attrib_fileInit(file, fileName, 0);
        }
        convert_hv2file(hv, file);
    }
#line 1699 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dir");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BackupPC__XS__Attrib	dir;
#line 698 "BackupPC_XS.xs"
#line 1718 "BackupPC_XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::digest",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;
#line 699 "BackupPC_XS.xs"
    {
        bpc_digest *digest = bpc_attrib_dirDigestGet(dir);
        if ( digest && digest->len > 0 ) {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpvn((char*)digest->digest, digest->len)));
        }
    }
#line 1741 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__Attrib_iterate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_iterate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dir, idx");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BackupPC__XS__Attrib	dir;
	unsigned int	idx = (unsigned int)SvUV(ST(1))
;
#line 712 "BackupPC_XS.xs"
        bpc_attrib_file *file;
#line 1762 "BackupPC_XS.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::iterate",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;
#line 714 "BackupPC_XS.xs"
    {
        if ( !bpc_attrib_fileIterate(dir, &file, &idx) && file ) {
            EXTEND(SP, 2);
            PUSHs(sv_2mortal(newRV_noinc((SV*)convert_file2hv(file, file->name))));
            PUSHs(sv_2mortal(newSViv(idx)));
        }
    }
#line 1785 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__Attrib_errStr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_errStr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
	char *	RETVAL;
	dXSTARG;
#line 725 "BackupPC_XS.xs"
        RETVAL = "TODO";
#line 1803 "BackupPC_XS.c"
	sv_setpv((SV*)TARG, RETVAL);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dir");
    {
	BackupPC__XS__Attrib	dir;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::count",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;
#line 733 "BackupPC_XS.xs"
        RETVAL = bpc_attrib_fileCount(dir);
#line 1837 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dir, fileName");
    {
	BackupPC__XS__Attrib	dir;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::delete",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;
#line 742 "BackupPC_XS.xs"
        bpc_attrib_fileDeleteName(dir, fileName);
#line 1871 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__Attrib_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_read)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dir, dirPath, attribFileName = \"attrib\"");
    {
	BackupPC__XS__Attrib	dir;
	char *	dirPath = (char *)SvPV_nolen(ST(1))
;
	char *	attribFileName;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::read",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    attribFileName = "attrib";
	else {
	    attribFileName = (char *)SvPV_nolen(ST(2))
;
	}
#line 750 "BackupPC_XS.xs"
        if ( !*dirPath ) dirPath = NULL;
        RETVAL = !bpc_attrib_dirRead(dir, dirPath, attribFileName, 0);
#line 1914 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_write)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "dir, dirPath, attribFileName, d = NULL, deltaInfo = NULL");
    {
	BackupPC__XS__Attrib	dir;
	char *	dirPath = (char *)SvPV_nolen(ST(1))
;
	char *	attribFileName = (char *)SvPV_nolen(ST(2))
;
	SV *	d;
	BackupPC__XS__DeltaRefCnt	deltaInfo;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::Attrib")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    dir = INT2PTR(BackupPC__XS__Attrib,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::Attrib::write",
			"dir", "BackupPC::XS::Attrib",
			refstr, ST(0)
		);
	}
;

	if (items < 4)
	    d = NULL;
	else {
	    d = ST(3)
;
	}

	if (items < 5)
	    deltaInfo = NULL;
	else {
	    if (SvROK(ST(4)) && sv_derived_from(ST(4), "BackupPC::XS::DeltaRefCnt")) {
		IV tmp = SvIV((SV*)SvRV(ST(4)));
		deltaInfo = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	    }
	    else {
		    const char* refstr = SvROK(ST(4)) ? "" : SvOK(ST(4)) ? "scalar " : "undef";
		Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			    "BackupPC::XS::Attrib::write",
			    "deltaInfo", "BackupPC::XS::DeltaRefCnt",
			    refstr, ST(4)
		    );
	    }
;
	}
#line 763 "BackupPC_XS.xs"
        if ( !*dirPath ) dirPath = NULL;
        if ( d && SvPOK(d) ) {
            bpc_digest digest;
            char *str;
            STRLEN len;

            str = SvPV(d, len);
            if ( 0 < len && len < sizeof(digest.digest) ) {
                memcpy(digest.digest, str, len);
                digest.len = len;
                RETVAL = !bpc_attrib_dirWrite(deltaInfo, dir, dirPath, attribFileName, &digest);
            } else {
                RETVAL = !bpc_attrib_dirWrite(deltaInfo, dir, dirPath, attribFileName, NULL);
            }
        } else {
            RETVAL = !bpc_attrib_dirWrite(deltaInfo, dir, dirPath, attribFileName, NULL);
        }
#line 1995 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_fileType2Text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_fileType2Text)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "type");
    {
	int	type = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 787 "BackupPC_XS.xs"
        RETVAL = bpc_attrib_fileType2Text(type);
#line 2016 "BackupPC_XS.c"
	sv_setpv((SV*)TARG, RETVAL);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Attrib_backwardCompat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Attrib_backwardCompat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "writeOldStyleAttribFile, keepOldAttribFiles");
    {
	int	writeOldStyleAttribFile = (int)SvIV(ST(0))
;
	int	keepOldAttribFiles = (int)SvIV(ST(1))
;
#line 796 "BackupPC_XS.xs"
        bpc_attrib_backwardCompat(writeOldStyleAttribFile, keepOldAttribFiles);
#line 2037 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "host, backupNum, shareNameUM, compress");
    {
	char *	host = (char *)SvPV_nolen(ST(0))
;
	int	backupNum = (int)SvIV(ST(1))
;
	char *	shareNameUM = (char *)SvPV_nolen(ST(2))
;
	int	compress = (int)SvIV(ST(3))
;
	BackupPC__XS__AttribCache	RETVAL;
#line 807 "BackupPC_XS.xs"
    {
        RETVAL = calloc(1, sizeof(bpc_attribCache_info));
        bpc_attribCache_init(RETVAL, host, backupNum, shareNameUM, compress);
    }
#line 2064 "BackupPC_XS.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BackupPC::XS::AttribCache", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ac");
    {
	BackupPC__XS__AttribCache	ac;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"BackupPC::XS::AttribCache::DESTROY",
			"ac")
;
#line 818 "BackupPC_XS.xs"
    {
        bpc_attribCache_destroy(ac);
        free(ac);
    }
#line 2099 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_setDeltaInfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_setDeltaInfo)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ac, deltaInfo");
    {
	BackupPC__XS__AttribCache	ac;
	BackupPC__XS__DeltaRefCnt	deltaInfo;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::setDeltaInfo",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "BackupPC::XS::DeltaRefCnt")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    deltaInfo = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::setDeltaInfo",
			"deltaInfo", "BackupPC::XS::DeltaRefCnt",
			refstr, ST(1)
		);
	}
;
#line 828 "BackupPC_XS.xs"
    {
        bpc_attribCache_setDeltaInfo(ac, deltaInfo);
    }
#line 2146 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_get)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "ac, fileName, allocateIfMissing = 0, dontReadInode = 0");
    {
	BackupPC__XS__AttribCache	ac;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	int	allocateIfMissing;
	int	dontReadInode;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::get",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    allocateIfMissing = 0;
	else {
	    allocateIfMissing = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    dontReadInode = 0;
	else {
	    dontReadInode = (int)SvIV(ST(3))
;
	}
#line 839 "BackupPC_XS.xs"
    {
        bpc_attrib_file *file = bpc_attribCache_getFile(ac, fileName, allocateIfMissing, dontReadInode);

        if ( !file ) XSRETURN_UNDEF;

        RETVAL = newRV_noinc((SV*)convert_file2hv(file, file->name));
    }
#line 2201 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_set)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "ac, fileName, hv, dontOverwriteInode = 0");
    {
	BackupPC__XS__AttribCache	ac;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	HV *	hv;
	int	dontOverwriteInode;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::set",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hv = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"BackupPC::XS::AttribCache::set",
				"hv");
		}
	} STMT_END
;

	if (items < 4)
	    dontOverwriteInode = 0;
	else {
	    dontOverwriteInode = (int)SvIV(ST(3))
;
	}
#line 856 "BackupPC_XS.xs"
    {
        bpc_attrib_file *file = bpc_attribCache_getFile(ac, fileName, 1, 0);

        convert_hv2file(hv, file);
        RETVAL = bpc_attribCache_setFile(ac, fileName, file, dontOverwriteInode);
    }
#line 2265 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ac, fileName");
    {
	BackupPC__XS__AttribCache	ac;
	char *	fileName = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::delete",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;
#line 870 "BackupPC_XS.xs"
        RETVAL = bpc_attribCache_deleteFile(ac, fileName);
#line 2301 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_getInode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_getInode)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ac, inode, allocateIfMissing = 0");
    {
	BackupPC__XS__AttribCache	ac;
	unsigned long	inode = (unsigned long)SvUV(ST(1))
;
	int	allocateIfMissing;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::getInode",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    allocateIfMissing = 0;
	else {
	    allocateIfMissing = (int)SvIV(ST(2))
;
	}
#line 880 "BackupPC_XS.xs"
    {
        bpc_attrib_file *file = bpc_attribCache_getInode(ac, inode, allocateIfMissing);

        if ( !file ) XSRETURN_UNDEF;

        RETVAL = newRV_noinc((SV*)convert_file2hv(file, file->name));
    }
#line 2350 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_setInode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_setInode)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ac, inode, hv");
    {
	BackupPC__XS__AttribCache	ac;
	unsigned long	inode = (unsigned long)SvUV(ST(1))
;
	HV *	hv;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::setInode",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    hv = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"BackupPC::XS::AttribCache::setInode",
				"hv");
		}
	} STMT_END
;
#line 896 "BackupPC_XS.xs"
    {
        bpc_attrib_file *file = bpc_attribCache_getInode(ac, inode, 1);

        convert_hv2file(hv, file);
        RETVAL = bpc_attribCache_setInode(ac, inode, file);
    }
#line 2406 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_deleteInode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_deleteInode)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ac, inode");
    {
	BackupPC__XS__AttribCache	ac;
	unsigned long	inode = (unsigned long)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::deleteInode",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;
#line 910 "BackupPC_XS.xs"
        RETVAL = bpc_attribCache_deleteInode(ac, inode);
#line 2442 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_count)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ac, path");
    {
	BackupPC__XS__AttribCache	ac;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::count",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;
#line 919 "BackupPC_XS.xs"
        RETVAL = bpc_attribCache_getDirEntryCnt(ac, path);
#line 2478 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_getAll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_getAll)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ac, path, dontReadInode = 0");
    {
	BackupPC__XS__AttribCache	ac;
	char *	path = (char *)SvPV_nolen(ST(1))
;
	int	dontReadInode;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::getAll",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	if (items < 3)
	    dontReadInode = 0;
	else {
	    dontReadInode = (int)SvIV(ST(2))
;
	}
#line 929 "BackupPC_XS.xs"
    {
        ssize_t entrySize, i;
        char pathCopy[BPC_MAXPATHLEN];

        snprintf(pathCopy, sizeof(pathCopy), "%s", path);
        RETVAL = NULL;
        if ( (entrySize = bpc_attribCache_getDirEntries(ac, pathCopy, NULL, 0)) > 0 ) {
            char *entries = malloc(entrySize), *p;

            if ( entries && bpc_attribCache_getDirEntries(ac, pathCopy, entries, entrySize) > 0 ) {
                HV *rh = newHV();
                for ( i = 0, p = entries ; i < entrySize ; ) {
                    int len = strlen(p);
                    char *fileNameSave = p;
                    char filePath[BPC_MAXPATHLEN];
                    bpc_attrib_file *file;

                    snprintf(filePath, sizeof(filePath), "%s/%s", path, p);
                    file = bpc_attribCache_getFile(ac, filePath, 0, dontReadInode);
                    p += len + 1 + sizeof(ino_t);
                    i += len + 1 + sizeof(ino_t);
                    if ( !file ) continue;
                    /* printf("Storing file name %s for path %s\n", fileNameSave, path); */
                    (void)hv_store(rh, fileNameSave, strlen(fileNameSave), newRV_noinc((SV*)convert_file2hv(file, fileNameSave)), 0);
                }
                RETVAL = newRV_noinc((SV*)rh);
            }
            if ( entries ) free(entries);
        }
        if ( !RETVAL ) XSRETURN_UNDEF;
    }
#line 2551 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_flush)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ac, all = 1, path = NULL");
    {
	BackupPC__XS__AttribCache	ac;
	int	all;
	char *	path;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::flush",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;

	if (items < 2)
	    all = 1;
	else {
	    all = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    path = NULL;
	else {
	    path = (char *)SvPV_nolen(ST(2))
;
	}
#line 969 "BackupPC_XS.xs"
        bpc_attribCache_flush(ac, all, path);
#line 2599 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__AttribCache_getFullMangledPath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__AttribCache_getFullMangledPath)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ac, dirName");
    {
	BackupPC__XS__AttribCache	ac;
	char *	dirName = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "BackupPC::XS::AttribCache")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ac = INT2PTR(BackupPC__XS__AttribCache,tmp);
	}
	else {
		const char* refstr = SvROK(ST(0)) ? "" : SvOK(ST(0)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"BackupPC::XS::AttribCache::getFullMangledPath",
			"ac", "BackupPC::XS::AttribCache",
			refstr, ST(0)
		);
	}
;
#line 976 "BackupPC_XS.xs"
    {
        char path[BPC_MAXPATHLEN];
        bpc_attribCache_getFullMangledPath(ac, path, dirName, -1);
        RETVAL = newSVpvn(path, strlen(path));
    }
#line 2636 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__FileDigest_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__FileDigest_digest)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fileName, compress");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	fileName = (char *)SvPV_nolen(ST(0))
;
	int	compress = (int)SvIV(ST(1))
;
#line 991 "BackupPC_XS.xs"
#line 2658 "BackupPC_XS.c"
#line 992 "BackupPC_XS.xs"
    {
        bpc_digest digest;
        if ( bpc_fileDigest(fileName, compress, &digest) == 0 ) {
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSVpvn((char*)digest.digest, digest.len)));
        }
    }
#line 2667 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__DirOps_path_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_path_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "path");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 1006 "BackupPC_XS.xs"
        RETVAL = bpc_path_create(path);
#line 2687 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_path_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_path_remove)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "path, compress, deltaInfo = NULL");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	compress = (int)SvIV(ST(1))
;
	BackupPC__XS__DeltaRefCnt	deltaInfo;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    deltaInfo = NULL;
	else {
	    if (SvROK(ST(2)) && sv_derived_from(ST(2), "BackupPC::XS::DeltaRefCnt")) {
		IV tmp = SvIV((SV*)SvRV(ST(2)));
		deltaInfo = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	    }
	    else {
		    const char* refstr = SvROK(ST(2)) ? "" : SvOK(ST(2)) ? "scalar " : "undef";
		Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			    "BackupPC::XS::DirOps::path_remove",
			    "deltaInfo", "BackupPC::XS::DeltaRefCnt",
			    refstr, ST(2)
		    );
	    }
;
	}
#line 1016 "BackupPC_XS.xs"
        RETVAL = bpc_path_remove(deltaInfo, path, compress);
#line 2729 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_refCountAll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_refCountAll)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "path, compress, incr = 1, deltaInfo = NULL");
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	compress = (int)SvIV(ST(1))
;
	int	incr;
	BackupPC__XS__DeltaRefCnt	deltaInfo;
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    incr = 1;
	else {
	    incr = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    deltaInfo = NULL;
	else {
	    if (SvROK(ST(3)) && sv_derived_from(ST(3), "BackupPC::XS::DeltaRefCnt")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		deltaInfo = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	    }
	    else {
		    const char* refstr = SvROK(ST(3)) ? "" : SvOK(ST(3)) ? "scalar " : "undef";
		Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			    "BackupPC::XS::DirOps::refCountAll",
			    "deltaInfo", "BackupPC::XS::DeltaRefCnt",
			    refstr, ST(3)
		    );
	    }
;
	}
#line 1027 "BackupPC_XS.xs"
        RETVAL = bpc_path_refCountAll(deltaInfo, path, compress, incr);
#line 2779 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_refCountAllInodeMax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_refCountAllInodeMax)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "path, compress, incr = 1, deltaInfo = NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	path = (char *)SvPV_nolen(ST(0))
;
	int	compress = (int)SvIV(ST(1))
;
	int	incr;
	BackupPC__XS__DeltaRefCnt	deltaInfo;
#line 1038 "BackupPC_XS.xs"
        int retVal;
        unsigned int inodeMax = 0;
#line 2805 "BackupPC_XS.c"

	if (items < 3)
	    incr = 1;
	else {
	    incr = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    deltaInfo = NULL;
	else {
	    if (SvROK(ST(3)) && sv_derived_from(ST(3), "BackupPC::XS::DeltaRefCnt")) {
		IV tmp = SvIV((SV*)SvRV(ST(3)));
		deltaInfo = INT2PTR(BackupPC__XS__DeltaRefCnt,tmp);
	    }
	    else {
		    const char* refstr = SvROK(ST(3)) ? "" : SvOK(ST(3)) ? "scalar " : "undef";
		Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			    "BackupPC::XS::DirOps::refCountAllInodeMax",
			    "deltaInfo", "BackupPC::XS::DeltaRefCnt",
			    refstr, ST(3)
		    );
	    }
;
	}
#line 1041 "BackupPC_XS.xs"
    {
        retVal = bpc_path_refCountAllInodeMax(deltaInfo, path, compress, incr, &inodeMax);
        EXTEND(SP, 2);
        PUSHs(sv_2mortal(newSViv(retVal)));
        PUSHs(sv_2mortal(newSViv(inodeMax)));
    }
#line 2838 "BackupPC_XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BackupPC__XS__DirOps_lockRangeFd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_lockRangeFd)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fd, offset, len, block");
    {
	int	fd = (int)SvIV(ST(0))
;
	unsigned int	offset = (unsigned int)SvUV(ST(1))
;
	unsigned int	len = (unsigned int)SvUV(ST(2))
;
	int	block = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
#line 1055 "BackupPC_XS.xs"
        RETVAL = bpc_lockRangeFd(fd, offset, len, block);
#line 2864 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_unlockRangeFd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_unlockRangeFd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, offset, len");
    {
	int	fd = (int)SvIV(ST(0))
;
	unsigned int	offset = (unsigned int)SvUV(ST(1))
;
	unsigned int	len = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 1065 "BackupPC_XS.xs"
        RETVAL = bpc_unlockRangeFd(fd, offset, len);
#line 2889 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_lockRangeFile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_lockRangeFile)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "lockFile, offset, len, block");
    {
	char *	lockFile = (char *)SvPV_nolen(ST(0))
;
	unsigned int	offset = (unsigned int)SvUV(ST(1))
;
	unsigned int	len = (unsigned int)SvUV(ST(2))
;
	int	block = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
#line 1076 "BackupPC_XS.xs"
        RETVAL = bpc_lockRangeFile(lockFile, offset, len, block);
#line 2916 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__DirOps_unlockRangeFile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__DirOps_unlockRangeFile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lockFd");
    {
	int	lockFd = (int)SvIV(ST(0))
;
#line 1084 "BackupPC_XS.xs"
        bpc_unlockRangeFile(lockFd);
#line 2935 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__Lib_ConfInit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Lib_ConfInit)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "topDir, hardLinkMax, poolV3Enabled, logLevel = 0");
    {
	char *	topDir = (char *)SvPV_nolen(ST(0))
;
	int	hardLinkMax = (int)SvIV(ST(1))
;
	int	poolV3Enabled = (int)SvIV(ST(2))
;
	int	logLevel;

	if (items < 4)
	    logLevel = 0;
	else {
	    logLevel = (int)SvIV(ST(3))
;
	}
#line 1095 "BackupPC_XS.xs"
        bpc_lib_conf_init(topDir, hardLinkMax, poolV3Enabled, logLevel);
#line 2964 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BackupPC__XS__Lib_logMsgGet); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Lib_logMsgGet)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 1100 "BackupPC_XS.xs"
    {
        char *mesg, *p;
        size_t mesgLen, i;
        AV *ra;

        RETVAL = NULL;
        bpc_logMsgGet(&mesg, &mesgLen);
        if ( mesgLen == 0 ) XSRETURN_UNDEF;

        ra = newAV();
        for ( i = 0, p = mesg ; i < mesgLen ; ) {
            int len = strlen(p);

            av_push(ra, newSVpvn(p, len));
            p += len + 1;
            i += len + 1;
        }
        RETVAL = newRV_noinc((SV*)ra);
    }
#line 2998 "BackupPC_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Lib_logErrorCntGet); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Lib_logErrorCntGet)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1125 "BackupPC_XS.xs"
    {
        unsigned long errorCnt;
        bpc_logMsgErrorCntGet(&errorCnt);
        RETVAL = errorCnt;
    }
#line 3021 "BackupPC_XS.c"
	TARGi((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BackupPC__XS__Lib_logLevelSet); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BackupPC__XS__Lib_logLevelSet)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "logLevel");
    {
	int	logLevel = (int)SvIV(ST(0))
;
#line 1137 "BackupPC_XS.xs"
        bpc_lib_setLogLevel(logLevel);
#line 3040 "BackupPC_XS.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_BackupPC__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_BackupPC__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("BackupPC::XS::FileZIO::open", XS_BackupPC__XS__FileZIO_open);
        newXS_deffile("BackupPC::XS::FileZIO::fdopen", XS_BackupPC__XS__FileZIO_fdopen);
        newXS_deffile("BackupPC::XS::FileZIO::DESTROY", XS_BackupPC__XS__FileZIO_DESTROY);
        newXS_deffile("BackupPC::XS::FileZIO::close", XS_BackupPC__XS__FileZIO_close);
        newXS_deffile("BackupPC::XS::FileZIO::rewind", XS_BackupPC__XS__FileZIO_rewind);
        newXS_deffile("BackupPC::XS::FileZIO::write", XS_BackupPC__XS__FileZIO_write);
        newXS_deffile("BackupPC::XS::FileZIO::read", XS_BackupPC__XS__FileZIO_read);
        newXS_deffile("BackupPC::XS::FileZIO::readLine", XS_BackupPC__XS__FileZIO_readLine);
        newXS_deffile("BackupPC::XS::FileZIO::writeTeeStderr", XS_BackupPC__XS__FileZIO_writeTeeStderr);
        newXS_deffile("BackupPC::XS::PoolRefCnt::new", XS_BackupPC__XS__PoolRefCnt_new);
        newXS_deffile("BackupPC::XS::PoolRefCnt::DESTROY", XS_BackupPC__XS__PoolRefCnt_DESTROY);
        newXS_deffile("BackupPC::XS::PoolRefCnt::get", XS_BackupPC__XS__PoolRefCnt_get);
        newXS_deffile("BackupPC::XS::PoolRefCnt::set", XS_BackupPC__XS__PoolRefCnt_set);
        newXS_deffile("BackupPC::XS::PoolRefCnt::delete", XS_BackupPC__XS__PoolRefCnt_delete);
        newXS_deffile("BackupPC::XS::PoolRefCnt::incr", XS_BackupPC__XS__PoolRefCnt_incr);
        newXS_deffile("BackupPC::XS::PoolRefCnt::iterate", XS_BackupPC__XS__PoolRefCnt_iterate);
        newXS_deffile("BackupPC::XS::PoolRefCnt::read", XS_BackupPC__XS__PoolRefCnt_read);
        newXS_deffile("BackupPC::XS::PoolRefCnt::write", XS_BackupPC__XS__PoolRefCnt_write);
        newXS_deffile("BackupPC::XS::PoolRefCnt::print", XS_BackupPC__XS__PoolRefCnt_print);
        newXS_deffile("BackupPC::XS::PoolRefCnt::DeltaFileInit", XS_BackupPC__XS__PoolRefCnt_DeltaFileInit);
        newXS_deffile("BackupPC::XS::PoolRefCnt::DeltaFileFlush", XS_BackupPC__XS__PoolRefCnt_DeltaFileFlush);
        newXS_deffile("BackupPC::XS::PoolRefCnt::DeltaUpdate", XS_BackupPC__XS__PoolRefCnt_DeltaUpdate);
        newXS_deffile("BackupPC::XS::PoolRefCnt::DeltaPrint", XS_BackupPC__XS__PoolRefCnt_DeltaPrint);
        newXS_deffile("BackupPC::XS::DeltaRefCnt::new", XS_BackupPC__XS__DeltaRefCnt_new);
        newXS_deffile("BackupPC::XS::DeltaRefCnt::DESTROY", XS_BackupPC__XS__DeltaRefCnt_DESTROY);
        newXS_deffile("BackupPC::XS::DeltaRefCnt::flush", XS_BackupPC__XS__DeltaRefCnt_flush);
        newXS_deffile("BackupPC::XS::DeltaRefCnt::update", XS_BackupPC__XS__DeltaRefCnt_update);
        newXS_deffile("BackupPC::XS::DeltaRefCnt::print", XS_BackupPC__XS__DeltaRefCnt_print);
        newXS_deffile("BackupPC::XS::PoolWrite::new", XS_BackupPC__XS__PoolWrite_new);
        newXS_deffile("BackupPC::XS::PoolWrite::DESTROY", XS_BackupPC__XS__PoolWrite_DESTROY);
        newXS_deffile("BackupPC::XS::PoolWrite::close", XS_BackupPC__XS__PoolWrite_close);
        newXS_deffile("BackupPC::XS::PoolWrite::write", XS_BackupPC__XS__PoolWrite_write);
        newXS_deffile("BackupPC::XS::PoolWrite::addToPool", XS_BackupPC__XS__PoolWrite_addToPool);
        newXS_deffile("BackupPC::XS::Attrib::new", XS_BackupPC__XS__Attrib_new);
        newXS_deffile("BackupPC::XS::Attrib::DESTROY", XS_BackupPC__XS__Attrib_DESTROY);
        newXS_deffile("BackupPC::XS::Attrib::get", XS_BackupPC__XS__Attrib_get);
        newXS_deffile("BackupPC::XS::Attrib::set", XS_BackupPC__XS__Attrib_set);
        newXS_deffile("BackupPC::XS::Attrib::digest", XS_BackupPC__XS__Attrib_digest);
        newXS_deffile("BackupPC::XS::Attrib::iterate", XS_BackupPC__XS__Attrib_iterate);
        newXS_deffile("BackupPC::XS::Attrib::errStr", XS_BackupPC__XS__Attrib_errStr);
        newXS_deffile("BackupPC::XS::Attrib::count", XS_BackupPC__XS__Attrib_count);
        newXS_deffile("BackupPC::XS::Attrib::delete", XS_BackupPC__XS__Attrib_delete);
        newXS_deffile("BackupPC::XS::Attrib::read", XS_BackupPC__XS__Attrib_read);
        newXS_deffile("BackupPC::XS::Attrib::write", XS_BackupPC__XS__Attrib_write);
        newXS_deffile("BackupPC::XS::Attrib::fileType2Text", XS_BackupPC__XS__Attrib_fileType2Text);
        newXS_deffile("BackupPC::XS::Attrib::backwardCompat", XS_BackupPC__XS__Attrib_backwardCompat);
        newXS_deffile("BackupPC::XS::AttribCache::new", XS_BackupPC__XS__AttribCache_new);
        newXS_deffile("BackupPC::XS::AttribCache::DESTROY", XS_BackupPC__XS__AttribCache_DESTROY);
        newXS_deffile("BackupPC::XS::AttribCache::setDeltaInfo", XS_BackupPC__XS__AttribCache_setDeltaInfo);
        newXS_deffile("BackupPC::XS::AttribCache::get", XS_BackupPC__XS__AttribCache_get);
        newXS_deffile("BackupPC::XS::AttribCache::set", XS_BackupPC__XS__AttribCache_set);
        newXS_deffile("BackupPC::XS::AttribCache::delete", XS_BackupPC__XS__AttribCache_delete);
        newXS_deffile("BackupPC::XS::AttribCache::getInode", XS_BackupPC__XS__AttribCache_getInode);
        newXS_deffile("BackupPC::XS::AttribCache::setInode", XS_BackupPC__XS__AttribCache_setInode);
        newXS_deffile("BackupPC::XS::AttribCache::deleteInode", XS_BackupPC__XS__AttribCache_deleteInode);
        newXS_deffile("BackupPC::XS::AttribCache::count", XS_BackupPC__XS__AttribCache_count);
        newXS_deffile("BackupPC::XS::AttribCache::getAll", XS_BackupPC__XS__AttribCache_getAll);
        newXS_deffile("BackupPC::XS::AttribCache::flush", XS_BackupPC__XS__AttribCache_flush);
        newXS_deffile("BackupPC::XS::AttribCache::getFullMangledPath", XS_BackupPC__XS__AttribCache_getFullMangledPath);
        newXS_deffile("BackupPC::XS::FileDigest::digest", XS_BackupPC__XS__FileDigest_digest);
        newXS_deffile("BackupPC::XS::DirOps::path_create", XS_BackupPC__XS__DirOps_path_create);
        newXS_deffile("BackupPC::XS::DirOps::path_remove", XS_BackupPC__XS__DirOps_path_remove);
        newXS_deffile("BackupPC::XS::DirOps::refCountAll", XS_BackupPC__XS__DirOps_refCountAll);
        newXS_deffile("BackupPC::XS::DirOps::refCountAllInodeMax", XS_BackupPC__XS__DirOps_refCountAllInodeMax);
        newXS_deffile("BackupPC::XS::DirOps::lockRangeFd", XS_BackupPC__XS__DirOps_lockRangeFd);
        newXS_deffile("BackupPC::XS::DirOps::unlockRangeFd", XS_BackupPC__XS__DirOps_unlockRangeFd);
        newXS_deffile("BackupPC::XS::DirOps::lockRangeFile", XS_BackupPC__XS__DirOps_lockRangeFile);
        newXS_deffile("BackupPC::XS::DirOps::unlockRangeFile", XS_BackupPC__XS__DirOps_unlockRangeFile);
        newXS_deffile("BackupPC::XS::Lib::ConfInit", XS_BackupPC__XS__Lib_ConfInit);
        newXS_deffile("BackupPC::XS::Lib::logMsgGet", XS_BackupPC__XS__Lib_logMsgGet);
        newXS_deffile("BackupPC::XS::Lib::logErrorCntGet", XS_BackupPC__XS__Lib_logErrorCntGet);
        newXS_deffile("BackupPC::XS::Lib::logLevelSet", XS_BackupPC__XS__Lib_logLevelSet);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
